/* Solution for Turing TAE->TMD J.K. */

#include <stdio.h>

#include <stdio.h>
#include <stdlib.h>

#define DEBUG 0
#define INPDEB 0
#define OPDEBUG 0

int state=0 ; 
int symbols=9 ;
int numpars ;

#define BUFLEN 1100
char line[BUFLEN],*ptr ;

#define STM 20

struct rulestr {
  int st,symb,news,newst ; char act ; 
  struct rulestr *next ;
} *rules ;

void ruleadd(int st,int symb,int news,int newst,char act)
{ struct rulestr *p ;
  p=malloc(sizeof(struct rulestr)) ;  
  if (!p) { printf("Out of memory.\n") ; exit(-1) ; }
  p->st=st ; p->symb=symb ; p->news=news ; p->act=act ;
  p->newst=newst ;   p->next=rules ; rules=p ;
}

void mruleadd(int st,int newst,char act)
     /* multiple */
{ int i ;
  for (i=-1;i<=symbols;i++) ruleadd(st,i,i,newst,act) ;
}

void moveleft()
{ int j ;
  for (j=0;j<20;j+=2) mruleadd(state*STM+j,(state+1)*STM+j,'L') ;
  state++ ;
}

void moveright()
{ int j ;
  for (j=0;j<20;j+=2) mruleadd(state*STM+j,(state+1)*STM+j,'R') ;
  state++ ;
}

void overwrite(int symb)
{ int j,i ;
  for (j=0;j<20;j+=2) 
    for (i=-1;i<=symbols;i++) { 
      ruleadd(state*STM+j,i,symb,state*STM+1+j,'R') ;
      ruleadd(state*STM+1+j,i,i,(state+1)*STM+j,'L') ;
    }
  state++ ;
}

void store()
{ int j,i,k ;
 for (i=0;i<=9;i++) {
   mruleadd(state*STM+i*2+1,(state+1)*STM+i*2,'L') ;
   for (j=0;j<20;j+=2) 
     for (k=0;k<2;k++) 
       ruleadd(state*STM+j,i+20*k,i+20*k,state*STM+1+i*2,'R') ;
 }
 state++ ;
}

void recallmark()
{ int j,i ;
  for (j=0;j<20;j+=2) 
    for (i=-1;i<=symbols;i++) { 
      ruleadd(state*STM+j,i,20+j/2,state*STM+1+j,'R') ;
      ruleadd(state*STM+1+j,i,i,(state+1)*STM+j,'L') ;
    }
  state++ ;
}

void addwithcarry()
{ int j,i ;
  for (j=0;j<20;j+=2) 
    for (i=-1;i<=symbols;i++) 
      if (i>=0 && i<=9) {
	if (i+j/2<10) ruleadd(state*STM+j,i,i+j/2,(state+1)*STM+j,'L') ;
        else  ruleadd(state*STM+j,i,i+j/2-10,state*STM+j+1,'L') ;
        if (i<9) ruleadd(state*STM+j+1,i,i+1,(state+1)*STM+j,'L') ;
	else ruleadd(state*STM+j+1,9,0,state*STM+j+1,'L') ;
      } else {
    ruleadd(state*STM+j,i,j/2,(state+1)*STM+j,'L') ;
    ruleadd(state*STM+j+1,i,1,(state+1)*STM+j,'L') ;
    }
  state++ ;
}

void multonedigit()
{ int j,i ;

 for(j=0;j<10;j++)
     for (i=-1;i<=symbols;i++) 
       if (i>=0 && i<=9) {
	  ruleadd(state*STM+j*2,i,(i*j)%10,(state+1)*STM,'L') ;
       }
  state++ ;
}


void unmark()
{ int j,i ;
 for (j=0;j<20;j+=2) {
   mruleadd(state*STM+1+j,(state+1)*STM+j,'L') ;
    for (i=-1;i<=symbols;i++)
      if (i>=20 && i<=29) 
	ruleadd(state*STM+j,i,i-20,state*STM+1+j,'R') ;
      else ruleadd(state*STM+j,i,i,state*STM+1+j,'R') ;
 }
 state++ ;
}

void unmarkleft()
{ int j,i ;
 for (j=0;j<20;j+=2) {
   mruleadd(state*STM+1+j,(state+1)*STM+j,'R') ;
   for (i=-1;i<=symbols;i++) 
     if (i>=20 && i<=29) ruleadd(state*STM+j,i,i-20,state*STM+j,'L') ; 
     else ruleadd(state*STM+j,i,i,state*STM+j+1,'L') ;
 }
 state++ ;
}


void mark()
{ int j,i ;
 for (j=0;j<20;j+=2) {
   mruleadd(state*STM+1+j,(state+1)*STM+j,'L') ;
    for (i=0;i<=9;i++) 
      ruleadd(state*STM+j,i,i+20,state*STM+1+j,'R') ;
    for (i=10;i<=symbols;i++) 
      ruleadd(state*STM+j,i,i,state*STM+1+j,'R') ;
    ruleadd(state*STM+j,-1,-1,state*STM+1+j,'R') ;
 }
 state++ ;
}

void findright(int symb)
{ int j,i ;
 for (j=0;j<20;j+=2) {
    for (i=-1;i<=symbols;i++) 
      if (i!=symb) ruleadd(state*STM+j,i,i,state*STM+j,'R') ;
       else        ruleadd(state*STM+j,i,i,state*STM+1+j,'R') ;
    mruleadd(state*STM+1+j,(state+1)*STM+j,'L') ;
 }
  state++ ;
}

void findleft(int symb)
{ int j,i ;
 for (j=0;j<20;j+=2) {
    for (i=-1;i<=symbols;i++) 
      if (i!=symb) ruleadd(state*STM+j,i,i,state*STM+j,'L') ;
       else        ruleadd(state*STM+j,i,i,state*STM+1+j,'L') ;
    mruleadd(state*STM+1+j,(state+1)*STM+j,'R') ;
 }
  state++ ;
}

void findleftnomark()
{ int j,i ;
 for (j=0;j<20;j+=2) {
    for (i=-1;i<=symbols;i++) 
      if (i>=20 && i<=29) ruleadd(state*STM+j,i,i,state*STM+j,'L') ;
       else        ruleadd(state*STM+j,i,i,state*STM+1+j,'L') ;
    mruleadd(state*STM+1+j,(state+1)*STM+j,'R') ;
 }
  state++ ;
}

void findleftmark()
{ int j,i ;
 for (j=0;j<20;j+=2) {
    for (i=-1;i<=symbols;i++) 
      if (!(i>=20 && i<=29)) ruleadd(state*STM+j,i,i,state*STM+j,'L') ;
       else        ruleadd(state*STM+j,i,i,state*STM+1+j,'L') ;
    mruleadd(state*STM+1+j,(state+1)*STM+j,'R') ;
 }
  state++ ;
}

void findrightmark()
{ int j,i ;
 for (j=0;j<20;j+=2) {
    for (i=-1;i<=symbols;i++) 
      if (!(i>=20 && i<=29)) ruleadd(state*STM+j,i,i,state*STM+j,'R') ;
       else        ruleadd(state*STM+j,i,i,state*STM+1+j,'R') ;
    mruleadd(state*STM+1+j,(state+1)*STM+j,'L') ;
 }
  state++ ;
}
 
int label() { return state ; }

void gotolabel(int l)
{ int i,j ;
 for (j=0;j<20;j+=2) 
   for (i=-1;i<=symbols;i++) {
      ruleadd(state*STM+j,i,i,state*STM+j+1,'R') ;
      ruleadd(state*STM+j+1,i,i,l*STM+j,'L') ;
   }
state++ ;
}

void instantiatelabel(int l)
{ int i,j ;
 for (j=0;j<20;j+=2) 
   for (i=-1;i<=symbols;i++) {
      ruleadd(l*STM+j,i,i,l*STM+j+1,'R') ;
      ruleadd(l*STM+j+1,i,i,state*STM+j,'L') ;
   }
}


int forwardlabel()
{ int l,i,j ;
  l=state+1 ; 
 for (j=0;j<20;j+=2) 
   for (i=-1;i<=symbols;i++) {
      ruleadd(state*STM+j,i,i,state*STM+j+1,'R') ;
      ruleadd(state*STM+j+1,i,i,(state+2)*STM+j,'L') ;
   }
state+=2 ;
  return l ; 
}


void gotolabelifnodigit(int l)
{ int i,j ;
 for (j=0;j<20;j+=2) 
   for (i=-1;i<=symbols;i++) {
     if ((i<0 || i>9)&&(i<20 || i>29)) 
       ruleadd(state*STM+j,i,i,state*STM+j+1,'R') ;
                else ruleadd(state*STM+j,i,i,(state+1)*STM+j,'R') ;
     ruleadd((state+1)*STM+j,i,i,(state+2)*STM+j,'L') ;
     ruleadd(state*STM+j+1,i,i,l*STM+j,'L') ;
   }
 state+=2 ;
}

void gotolabelifmark(int l)
{ int i,j ;
 for (j=0;j<20;j+=2) 
   for (i=-1;i<=symbols;i++) {
     if (!(i<20 || i>29))
       ruleadd(state*STM+j,i,i,state*STM+j+1,'R') ;
                else ruleadd(state*STM+j,i,i,(state+1)*STM+j,'R') ;
     ruleadd((state+1)*STM+j,i,i,(state+2)*STM+j,'L') ;
     ruleadd(state*STM+j+1,i,i,l*STM+j,'L') ;
   }
 state+=2 ;
}

void printrules()
{ struct rulestr *p,*q ;
  printf("%d %d\n",symbols,state*STM+2*STM-1) ;
  q=rules ;
  while(q) { p=q->next ; 
                 printf("%d %d %d %d %c\n",q->st,q->symb,
			q->news,q->newst,q->act) ;
		 q=p ; }
  puts("-") ;
}

void freerules()
{ struct rulestr *p ;
 while(rules) { p=rules->next ; free(rules) ; rules=p ; }
}

void parseerror(char *s)
{ printf("Parse error in `%s', unexpected `%c'(%d).\n",
	 s,*ptr>=' ' ? *ptr : 'N',*ptr) ; exit(-1); 
}

int mygetchar()
{ 
#if INPDEB
  printf("Looked up `%c'\n",*ptr>=' ' ? *ptr : 'N') ;
#endif
  return *ptr ;
}

void next()
{ 
#if INPDEB
  printf("Eaten `%c'\n",*ptr>=' ' ? *ptr : 'N') ;
#endif
  ptr++ ;
}

void pushvar(int i)
{ int l1,l2 ;
#if OPDEBUG 
  printf("Push %d\n",i) ;
#endif
  findright(10+i) ;
  moveleft() ; store() ; mark() ;
  findleft(31) ;
  moveleft() ;
  recallmark() ;
  l1=label() ;
  findright(10+i) ;
  moveleft() ;
  l2=forwardlabel() ;
  findleftnomark() ;
  gotolabelifnodigit(l2) ;
  store() ; 
  mark() ;
  findleft(31) ;
  moveleft() ;
  findleftnomark() ;
  recallmark() ;
  gotolabel(l1) ;
  instantiatelabel(l2) ;
  /* copying finished, clean up stack */
  findleft(31) ; moveleft() ; unmarkleft() ; overwrite(31) ;
  moveright() ; findright(31) ; overwrite(30) ;
  /* clean the source */
  findright(10+i) ; moveleft() ; unmarkleft() ; 
  /* back to start position */
  findleft(31) ;
}

void cleanupstack()
{ int l1,l2,l3 ;


  findleft(-1) ; overwrite(31) ; moveright() ; 
  findright(30) ; moveleft() ; unmarkleft() ; moveright() ; findright(30) ; 
  moveright() ; findright(30) ; 
  moveleft() ; unmarkleft() ;
  moveright() ; findright(30) ; moveleft() ; overwrite(31) ; moveleft() ; 
  findleft(30) ;
  moveleft() ;
  /* shorten stack */
  l1=label() ; l2=forwardlabel() ;
  gotolabelifnodigit(l2) ;
  findleftnomark() ; 
  gotolabelifnodigit(l2) ;
  store() ; mark() ;
  l3=forwardlabel() ;
  moveright() ;
  gotolabelifnodigit(l3) ;
  unmark() ;
  instantiatelabel(l3) ;
  findright(31) ; 
  recallmark() ; moveleft() ; overwrite(31) ;
  findleftmark() ;
  gotolabel(l1) ;
  instantiatelabel(l2) ;
  /* back to start position */
  overwrite(-1) ; moveright() ; overwrite(-1) ;
  findright(31) ; findright(30) ; moveleft() ; unmarkleft() ;
  overwrite(31) ; moveleft() ; overwrite(-1) ; moveright() ;
}

void add()
{ int l1,l2 ;
#if OPDEBUG
  printf("Add\n") ;
#endif
  findright(30) ; moveright() ;
  l1=label() ;
  l2=forwardlabel() ;
  findright(30) ; moveleft() ;
  findleftnomark() ;
  gotolabelifnodigit(l2) ;
  store() ; mark() ;
  findleft(30) ; moveleft() ;
  findleftnomark() ; addwithcarry() ;
  findright(30) ; moveleft() ; findleftnomark() ; mark() ;
  findright(30) ; moveright() ;
  gotolabel(l1) ;
  instantiatelabel(l2) ;
  /* adding finished, unmark */
  cleanupstack() ;
}

void mult()
{ int l1,l2,l3,l4 ;
#if OPDEBUG
  printf("Mult\n") ;
#endif
  findright(30) ; moveright() ;
  findright(30) ; moveleft() ;
  store() ; mark() ;
  findleft(30) ; moveleft() ;
  multonedigit() ; moveright() ; mark() ; moveleft() ;
  l1=label() ; l2=forwardlabel() ;
  gotolabelifnodigit(l2) ;
  overwrite(-1) ; 
  moveleft() ;
  gotolabel(l1) ; 
  instantiatelabel(l2) ;
  moveright() ;
  l3=label() ; l4=forwardlabel() ;
  gotolabelifmark(l4) ;
  mark() ;
  moveright() ;
  gotolabel(l3) ; 
  instantiatelabel(l4) ;
  moveleft() ; overwrite(31) ; findright(30) ;
  l3=label() ; l4=forwardlabel() ;
  gotolabelifmark(l4) ;
  mark() ;
  moveright() ;
  gotolabel(l3) ; 
  instantiatelabel(l4) ;
  findleft(30) ;
  /* mult finished, unmark */
  cleanupstack() ;
}

void factor() ;
void parse() ;
void rest() ;

void factorrest()
{ int c ;
  c=mygetchar() ;
  if (c=='*') { next() ; factor() ; mult() ; } else
  { if (c==')' || c=='+' || c=='\0') return ; 
    parseerror("factorrest") ;
  }
} 

void factor()
{ int c ;
  c=mygetchar() ;
  if (c=='(') { next() ; parse() ; c=mygetchar() ;
                if (c!=')') parseerror("factor )") ;
		next() ;
  } else { if (c>='0' && c<='9') {
      next() ;
      pushvar(c-'0') ;
      factorrest() ;} 
    else parseerror("factor") ;
  }
}


void rest()
{ int c ;
  c=mygetchar() ;
  if (c=='\0' || c==')') return ;
  if (c=='+') { next() ; parse() ; add() ; }
  else if (c=='*') { next() ; factor() ; mult() ; rest() ; }
  else parseerror("rest") ;
}



void parse()
{ int c ;
  c=mygetchar() ;
  if (c=='(') { factor() ; rest() ;
  } else {
    if (c>='0' && c<='9') {
      next() ;
      pushvar(c-'0') ;
      rest() ;} 
    else parseerror("parse") ;
  }
}
	    
void prepare()
{ int i ;
  
  moveleft() ;

  overwrite(31) ; /* stack end mark */
  for(i=1;i<=numpars;i++) {
    findright(-1) ;
    overwrite(10+i) ;
    moveright() ;
	    }
    /* end in state numpars+3 one position right from the rightmost mark */
    findleft(31) ;
  /* ready to go, head at the stack end mark */
}  


void solve()
{ 
 fgets(line,BUFLEN,stdin) ;
 for(ptr=line;*ptr && *ptr!='\n' && *ptr!='\r';ptr++) ;
 *ptr='\0' ; 
 rules=NULL ; state=0 ; symbols=31 ;
 for(numpars=0,ptr=line;*ptr;ptr++)
   if (*ptr>='0' && *ptr<='9' && *ptr-'0'>numpars) numpars=*ptr-'0' ;
 ptr=line ;
 prepare() ;
 parse() ;
 findright(30) ; overwrite(-1) ; findleft(31) ; moveright() ;
 printrules() ;
 freerules() ;
}  

int main(void) 
{ int c ;
  scanf("%d",&c) ;
  while(getchar()!='\n') ;
  while(c--) solve() ;
  return 0 ;
}
