/* Zajici a lisky, vzorove reseni. J.K. */
/* potrebuje matematickou knihovnu */

#include <stdio.h>
#include <math.h>


void solvele(double a,double b,double c,double d,double e,double f,double *x,double *y) 
     /* Solves [ a b ; c d ] * [x ; y ] = [ e ; f ] */
{ double det ;

#if 0
  printf("a=%g b=%g c=%g d=%g e=%g f=%g\n",a,b,c,d,e,f) ; 
#endif

  det=a*d-b*c ;
  *x=(e*d-b*f)/det ;
  *y=(a*f-c*e)/det ;

#if 0
  printf("x=%g y=%g\n",*x,*y) ; 
#endif

}

int one()
{ double a,b,c,d,z,l ;
  double B,C,D,x1,x2,m11,m12,m21,m22 ;
  scanf("%lf %lf %lf %lf %lf %lf",&a,&b,&c,&d,&z,&l) ;
  /* Sestavime charakteristickou rovnici soustavy x^2+Bx+C */
  B=-a-c ; C=a*c+b*d ;
  /* Vypocitame diskriminant */
  D=B*B-4*C ;

#if 0
  printf("a=%g b=%g c=%g d=%g\n",a,b,c,d) ;
  printf("B=%g C=%g D=%g\n",B,C,D) ;
#endif

  if (D<0) /* imaginarni koreny -> oscilace */
    { /* vypocitame realnou cast x=-B/2 */
      B=-B/2 ; D=sqrt(-D)/2 ;
      if ((B*B+D*D)<1 || (z==0.0 || l==0.0)) return 1 ; /* tlumene oscilace */
      return 6 ; /* netlumene oscilace */
    }  
  /* vypocitame koreny, tak aby |x1|>|x2| */
  D=sqrt(D)/2 ; B=-B/2 ; 
  x1=D+B ; x2=D-B ; 
  if (abs(x2)>abs(x1)) { x2=D+B ; x1=D-B ; } 

  /* kontrola nulovych poc. podminek */
  if (z==0.0 && l==0.0) return 1 ; 

  /* ted vyresime soustavu linearnich rovnic pro char. vektory */
  solvele(1.0,1.0,x1,x2,z,a*z-b*l,&m11,&m12) ;
  solvele(1.0,1.0,x1,x2,l,c*l+d*z,&m21,&m22) ;

  /* asymptoticky lze nyni zanedbat koren x2 */
  if (abs(x1)<1) return 1; 

#if 0
  printf("x1=%g x2=%g m11=%g m21=%g m12=%g m22=%g\n",x1,x2,m11,m21,m12,m22) ;
#endif

  /* nastava nejaky typ divergence */
  if (m11>0) { if (m21>0) return 5 ; else return 3 ; }
     else    { if (m21>0) return 2 ; else return 4 ; }
  /* sem bychom se nemeli dostat */
  return -1 ;
}

int main()
{ int n ;
  scanf("%d",&n) ;
  while(n--) 
    switch(one()) {
    case 1: printf("Ecological "  "balance" " will develop.\n") ; break ;
    case 2: printf(  "Hares"  " will "  "die out"  " while "  
    "foxes"  " will "  "overgrow"  ".\n") ; break ;
    case 3: printf(  "Hares"  " will "  "overgrow"  " while "  
    "foxes"  " will "  "die out"  ".\n") ; break ;
    case 4: printf(  "Both"  " hares and foxes will "  "die out"  ".\n") ;
            break ;
    case 5: printf(  "Both"  " hares and foxes will "  "overgrow"  ".\n") ;
            break ;
    case 6: printf(  "Chaos"  " will develop.\n") ; break ;

    default: puts("Unexpected result! Internal error.\n") ;
    }
  return 0 ;
}
